package AS;


/*
 * Gestore si mette in ascolto su una det 'porta in attesa di connessione. per gestire
 * la comunicazione crea un thread (GestoreThread). quest'ultimo verifica se si tratta
 * di un Client o di una Copia e agisce di conseguenza:
 * se client inoltra la richiesta ad una delle copie disponibili a fornire il servizio
 *  le richieste vengono inoltrate ciclicamente a tutte le copie 
 * se copia registra il suo indirizzo tra le copie disponibili a fornire il servizio e
 *  gli invia la tabella su cui lavorare.
 */

import java.net.*;
import java.io.*;
import java.util.ArrayList;
import com.entrust.util.*;
import iaik.security.rsa.*;
import java.security.*;
import Security.chiave;
import AS.Util.*;


public class  Gestore{
	protected int hostPort;
	protected ArrayList listaCopie = new ArrayList();
	protected int posizione = 0;				   //posizione all'interno dell'ArrayList della copia
	                                      //che deve fornire il servizio secondo l'ordine
	                                     //prestabilito (ciclico)
	protected int timestamp = 1;
	protected chiave keyS;
   public  Gestore() 	{ 
		hostPort =0;
	   System.out.println("mi spiace esco"); 
		
			}
	
	public  Gestore(int hostPort) 	{
		this.hostPort = hostPort;       //porta di ascolto del collegamento TCP
		////
		try{
			//REPERIMENTO DELLE CHIAVI DEL SERVER
			costanti cns = new costanti();
			keyS=new chiave(cns.getKPrServer(),cns.getKPbServer()); 
		   //keyS=new chiave("D:/Utenti/stefano/progetto/java/javaprova/keyprServer.txt","D:/Utenti/stefano/progetto/java/javaprova/keypbServer.txt");
		
			}
		catch( Exception e){
			System.out.println("Errore reperimento chiavi Server :"+e.getMessage()); 
			System.exit(1);}
	///
	} //costruttore

	//REPERIMENTO CHIAVI
	public RSAPrivateKey getSKeyPr() {
		return keyS.getPrivate();	}

	public RSAPublicKey getSKeyPb(){
		return keyS.getPublic(); 	}

	//GESTIONE LISTA COPIE "ATTIVE"
	public  void incposizione(){
		posizione++;}

	public synchronized int getposizione(){
		int p =posizione;
		incposizione();
		return p;}

	public synchronized void cancella(indirizzo adr){
		int pos=-1;
		pos=listaCopie.indexOf(adr);                     //viene effettuata prima una ricerca perch nel 
		if (pos !=-1) listaCopie.remove(pos);           //caso sia stata cancello un altro indirizzo, 
   }                                                 //la posizione in possesso delle copie diverrebbe 
                                                    //non consistente
	public void ins(indirizzo adr){
		System.out.print("inserisco nuovo indirizzo  ");
		//int t= listaCopie.lastIndexOf(null);
		if (listaCopie.contains(adr)) {System.out.println(" indirizzo gia' presente");}
		else{
			if (listaCopie.add(adr)) System.out.println(" ok inserito");
			 }
  }           

	//GESTIONE TIMESTAMP  
	public  void inctimestamp(){
		timestamp++;}

		public synchronized int gettimestamp(){
		int p =timestamp;
		inctimestamp();
		return p;}

	//BODY
  public void Comunica(){ 
		try {
			// crea la socket di ascolto
			ServerSocket listeningSocket = new ServerSocket(hostPort);
		
			while (true){
      		// crea la socket di connessione ==> ACCEPT
				Socket ClientSocket = listeningSocket.accept();
				System.out.println("Gestore - porta numero "+hostPort+" ricevuta richesta");
				//istanzia un THREAD per gestire la Socket di comunicazione
				(new GestoreThread(ClientSocket,this)).start();
			}//endwhile
			}//endtry	
		catch (SocketException se){
			System.out.println("Porta attualmente in uso: impossibile effettuare il bind");
			//System.exit(1);
			}
		catch (IOException ioe)  {
			System.err.println("Errore in accept: " + ioe.getMessage());         
		}
	} //endComunica

	public static void main(String args[])  {
		Gestore serverSocket=null;
		//controllo che ci sia un argomento...
		if(args.length!=1){
			System.err.println("usage: java Gestore port_number  \n"); //la porta riguarda la connessione TCP
			System.exit(1);
		}
                                       //...e che sia un intero
		try	{
			serverSocket= new Gestore((Integer.valueOf(args[0])).intValue());
			System.out.println("avvio ok");
		}
		catch(NumberFormatException e)  {
			System.out.println("port_number must be an integer\n");
			System.exit(1);
		}
    
		//System.out.println("chiamo Comunica ");
		if(!serverSocket.equals(null)) serverSocket.Comunica();
	}//main()

}//endGestore




