package AS;


/*
 *Gestore che mantiene una comunicazione TCP con il client, e una comunicazione UDP con la copia
 */

import java.net.*;
import java.io.*;
import AS.Util.*;
import java.util.ArrayList;
import java.util.Hashtable;
import Msg.PacketMsg;
import java.security.Signature;
import iaik.security.rsa.RSASignature;
import com.entrust.util.*;
import iaik.security.rsa.*;
import java.security.*;
import Exceptions.*; //InexistanceFileException;
import AS.Msg.*;


public class GestoreThread extends Thread{
	Socket postino;
	Gestore gestore;
	connettiTCP conn =null;
	

	public GestoreThread(Socket postino,Gestore gestore){
		this.postino=postino;
		this.gestore=gestore;
	}
	
	public void run(){
		
		try{			
			System.out.println("Aspetto il msg dal Client o da una nuova Copia.....");
			conn = new connettiTCP(postino);
			Object objC=conn.attendiRisposta();
			//System.out.println("ricevuto oggetto");
			
			if (objC instanceof indirizzo) {				   // X COPIA
						System.out.println(" e' un indirizzo");
						indirizzo ind =(indirizzo)objC;
						//leggo la tabella
						//Hashtable ht =(Hashtable)azione(ind);
						boolean riprova=true;
						do{
						  Sht sht=new Sht(conn,gestore.getSKeyPr(),gestore.getSKeyPb());		  
					     riprova=  sht.ServiceCopia();
						  
						  }while(!riprova);
						  
						  //fz Server di aggiornamento e verifica consistenza hashtable
						  //il primo passo  la lettura dell'Hashtable da file
						  //viene inviato la dimensione della tabella da leggere
						  //ogni singola entry viene poi firmata e spedita
						  //notare che ogni entry viene numerata a partire da un
						  //timestamp unico. Se anche il timestamp di una sola entry
						  //non coincide, la fz fallisce
						  //infine si riceve ultimo timestamp inviato, incrementato
						  //se tutto coincide (il msg  valido e il timestamp coincide)
						  //la fz restituisce true altrimenti attende il riinoltro
						  //della richiesta da parte della copia. La copia effettua fino  
						  //a 5 tentativi di aggiornamento, se nessuno riesce abbandona.
						  //Nel caso non sia possibile accedere al file viene generata
						  //un eccezione che in pratica chiude la socket in modo che
						  //la copia non rimanga indefinitivamente in attesa. In realt
						  //viene chiuso anche il gestore in quanto non ha senso di
						  //esistere se non ha una tabella hash (consistente) da fornire
						  //alle copie, inoltre l' assenza della tabella potrebbe 
						  //voler significare problemi o manomissioni.
						
						  //inserisco indirizzo della copia.
						  gestore.ins(ind);


						//boolean rinvio =false;
						
						/* PROTOCOLLO:
	 					 *                Gestore (Sht)                           Copia (cli)    
						 *                              dim   ====> 1 >>>>
						 *                            entry42 ====> 1 >>>>
						 *                            entry43 ====> 1 >>>>
						 *                              ...
						 *                            entry49 ====> 1 >>>>
						 *                            entry50 ====> 1 >>>>
						 *                                     << 2 <<<====    dim
						 *             
					    *
	 					 * 
						 * 
	 					 */
						
						}//endif3
						/////////////////////77

						if (objC instanceof reqCopieMsg) {				   // X COPIA
						System.out.println(" e' una richiesta da un Server Secondario");
						
						boolean riprova=true;
						do{
						  ShtS shts=new ShtS(conn,gestore.listaCopie,gestore.getSKeyPr(),gestore.getSKeyPb());		  
					     riprova=  shts.ServiceCopia();
						  
						  }while(!riprova);
						  
					
						
						}//endif3

						if (objC instanceof cindirizzo) {				   // X COPIA
						System.out.println(" avviso di una nuova copia attiva");
						indirizzo a =new indirizzo(((cindirizzo)objC).getadr(),((cindirizzo)objC).getport());
						gestore.ins((indirizzo)a);
							
						}//endif3

						//////////////////////
						Object risp =null;			 // X CLIENT
						requestMsg r=null;
						if (objC instanceof requestMsg) {    //Questo reqMsg contiene anche il timestamp del client
							r = (requestMsg)objC;
								if (gestore.listaCopie.isEmpty()) {
											System.out.println("vuoto");  //NESSUNA COPIA DISPONIBILE
											 risp=new notCopiaMsg(0); 
						        }  
								else{
					 			 // recupero la posizione corrispondente l'indirizzo della 
							 	 //copia che devo contattare
							 	 int posizione =gestore.getposizione()%(gestore.listaCopie.size());
							 	 //gestore.inc();
						 
								 String name =(String)r.getName();
								 risp=(Object)azione(name, posizione);	
								 //questa funzione pu ritornare:
								 //noFindKey   : non esiste nella tabella quel nome
								 //answerKey   : tutto ok
								 //notCopiaMsg : indica l'assenza di copie in grado di fornire risposte
								 //il controllo che non ci sia stata modifica dei dati viene effettuato:
								 //in caso di refuse (msg modificato prima di giungere alla copia) la richiesta 
								 //  viene inoltrata automaticamente  dal metodo azione quando riceve dalla copia 
								 //  il msg di refuse
								 //in caso di modifica del messaggio di risposta, questo viene riscontrato dalla
								 //  signature.  Il metodo azione controlla che il messaggio ricevuto sia consistente, 
								 //in caso contrario riinoltra la richiesta.
						 		 //IMP: viene anche controllata la coincidenza dei timestamp per evitare il
								 //     replying dei msg(nel caso viene riinviata la richiesta
								 } //endelse
						
						
						//A questo punto devo mandare il messaggio al client con il SUO timestamp e con una
						//signature per l' autenticazione
						 if (risp instanceof answerKey)  {
														answerKey ansKey=(answerKey)risp;
   													answerMsg ansMsg=(answerMsg)ansKey.getObj();
														answerMsg msgClient=new answerMsg(ansMsg.getKey(),r.getN());  //timestamp del Client
														msgFirma firma=new msgFirma(msgClient);
														byte[] sign = firma.autentica(gestore.getSKeyPr());
														objC = new answerKey(msgClient,sign);
														}	  
														                              
						 if (risp instanceof notFindKey) {	
														notFindKey nfKey=(notFindKey)risp;
														notFindMsg nfMsg=(notFindMsg)nfKey.getObj();
														notFindMsg msgClient=new notFindMsg(r.getN());  //timestamp del Client
														msgFirma firma=new msgFirma(msgClient);
														byte[] sign = firma.autentica(gestore.getSKeyPr());
														objC = new notFindKey(msgClient,sign);
														}	  
														                           
						 if (risp instanceof notCopiaMsg)  {
						 								notCopiaMsg msgClient=new notCopiaMsg(r.getN());  //timestamp del Client
														msgFirma firma=new msgFirma(msgClient);
														byte[] sign = firma.autentica(gestore.getSKeyPr());
														objC = new notCopiaKey(msgClient,sign);
														}
						conn.inviaMsg(objC);
				}//endif													  //IMPORTANTE
			
			  
			//la risposta puo essere una String name(+TIMESTAMP!!!!!!!!!!!!!) 
			//o un indirizzo di una Copia.  A seconda del tipo di oggetto ho 2 
			//azioni diverse da fare.					
			 
			
			conn.chiudi();
      	postino.close();
			
			System.out.println("sono qua! attendo richieste");
			} //endtry
		catch (InexistanceFileException eof){System.out.println("file hash inesistente"); System.exit(1);}
		catch (EOFException eof){System.err.println("ricezione attesa impossibile");}			   //$
		catch(Exception e){
			System.err.println("Errore 42:"+e.getMessage());
		}
	}//run

public Object azione(String name,int posizione){	//Rx nome del Client da ricercare >>>>>SYNCRONIZED
	//devo decidere a quale copia inviare la domanda 
	//per farlo ho un ARRAYLIST con gli indirizzi di tutte
	//le copie "attive"
	int tentativo;
 	Object risposta=null;
	boolean resta=false;
	boolean ritorna =false;
	int tsg =-1;
	
	do {		   //ciclo che eventualmente inoltra la richiesta a un'altra copia
		boolean ripeti=false;
		tentativo=0;
		System.out.println("tentativo = "+tentativo);
		if (!gestore.listaCopie.isEmpty()){		    
			  System.out.println("esiste l' indirizzo di una copia ");
			indirizzo adr = (indirizzo)gestore.listaCopie.get(posizione);
			//comunica con la copia
			do{					  //ciclo che effettua il rinvio del msg se necessario
				resta=false;
				tentativo++;
				try {
 			      tsg=gestore.gettimestamp();
					requestMsg r =new requestMsg(name,tsg);
					////////
					msgFirma firma=new msgFirma(r);
					byte[] sign = firma.autentica(gestore.getSKeyPr());  
					requestKey req = new requestKey(r,sign);

					///////7
					DtgRichiesta richiesta =null;
					//richiesta =new DtgRichiesta(adr.getport(),req);
					richiesta =new DtgRichiesta(adr,req);
					risposta = richiesta.InviaRicevi();
					}//endtry
				catch(Exception e){
					System.err.println("Errore: ......"+e.getMessage());
					}
				if ((risposta instanceof timeoutMsg) & (tentativo<2)) { 
			 		//System.out.println("tentativo <2 & timeout ");
					System.out.println("tentativo fallito - timeout ");
					resta=true;
					}
			}while (resta); 
			// se risposta==timeoutMsg -non  arrivato nessun messaggio di risposta ed  scattato timeout
			// se risposta==notFindKey - arrivato messaggio che indica la non corrispondenza con il nome passato
			// se risposta==answerKey  -tutto ok
 		   // se risposta==refuseKey  -indica la modifica dei dati prima che giungessero alla copia

		if (risposta instanceof timeoutMsg)  {System.out.println(" Copia non piu' attiva");
		                                      gestore.cancella(adr);
		                                      ritorna=true;}
	}//USCIRE DAL CICLO INTERNO CON TIMEOUT SIGNIFICA CONSIDERARE LA COPIA NON + VALIDA
	
	else {//nessuna copia disponibile
			System.out.println("nessuna copia disponibile");
			risposta =new notCopiaMsg(0);
			ritorna=false;}
	if (risposta instanceof answerKey)  {	//controllo la consistenza informazioni ricevute
														answerKey risp=(answerKey)risposta; 
														byte[] sign =risp.getsign();
														boolean ok=risp.verifica(sign,gestore.getSKeyPb()); 
														System.out.println("ok?  "+ok);
														if (ok){
															answerMsg a= (answerMsg)risp.getObj();
															if(a.getN()==tsg) {ritorna=false;}	   //CONTROLLO FRESCHEZZA MSG
															else{ripeti=true;}
															}
														else{ripeti=true;}	  //c' stata manipolazione msg ritorno
														}                                 //Riinoltro la richiesta
	if (risposta instanceof notFindKey) {	//controllo la consistenza informazioni ricevute
														notFindKey risp=(notFindKey)risposta;
														byte[] sign =risp.getsign();
														boolean ok=risp.verifica(sign,gestore.getSKeyPb()); 
														System.out.println("ok?  "+ok);
														if (ok){
															notFindMsg a= (notFindMsg)risp.getObj();
															if(a.getN()==tsg) {ritorna=false;}	   //CONTROLLO FRESCHEZZA MSG
															else{ripeti=true;}
															}
														else{ripeti=true;}	  //c' stata manipolazione msg ritorno
														}                                 //Riinoltro la richiesta
	if (risposta instanceof refuseKey)  {ripeti=true;}         //c' stata manipolazione msg andata
	if (ripeti){ritorna=true;tentativo=0;}
	}while (ritorna);
	// Nel caso una copia non risponda (msg di timeout per 2 volte consecutive) viene cancellato l'indirizzo
	//della copia da quelli disponibili e viene inoltrata la domanda a un altra copia.
	//nel caso non ci siano copie "attive" (in grado di fornire risposta) viene mandato un messaggio di 
	// notCopiaMsg: nessuna copia disponibile [risulta quindi impossibile avere in uscita un msg di
	//timeout perch nel caso viene cancellato indirizzo e riinoltrata la richiesta , Al max non si troveranno
	//pi indirizzi e verr lanciato un msg di notCopiaMsg ]
	//in caso il messaggio sia del tipo refuseMsg vuol dire che c' stata modifica dei dati e viene 
	//riinoltrata la richiesta
	//in tutti gli altri casi:
	//                             notFindKey
	//                             answerKey
	//IMPORTANTISSIMO  IL CONTROLLO DELLA FRESCHEZZA DEL MSG POICHE IL MSG POTREBBE NON ESSERE STATO
	//MODIFICATO MA POTREBBE ESSERE UN MSG VECCHIO RIUTILIZZATO ==>>NO REPLY MSG
					
	return risposta;
 //...
}//endazione 1 -con Client-


}//SeverThread
