package Dns.Gui;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import Dns.*;

public class PrimaryGui extends Frame implements WindowListener,ActionListener{
	PrimaryServer server;
	//Componenti interfaccia:
	GridBagLayout gridBagLayout = new GridBagLayout();
  Panel buttonPanel = new Panel();
  TextArea MsgArea = new TextArea();
  Button clearButton = new Button("Clear Output");
  Button bindButton = new Button("Add Binding");
	Button unbindButton = new Button("Delete Binding");
  Button delSubButton = new Button("Delegate Subdomain");
  TextArea OutputArea = new TextArea();
  Button addSubButton = new Button("Add Subdomain");
  GridLayout gridLayout = new GridLayout();

	
	public PrimaryGui(PrimaryServer server){
		this.server=server;
		
		//inizializzazione interfaccia:
		setSize(500, 400);
		setTitle("Primary NameServer "+server.getDomain().toString());
		addWindowListener(this);
    setBackground(Color.lightGray);
		buttonPanel.setLayout(gridLayout);
    setLayout(gridBagLayout);
    addSubButton.addActionListener(this);
		buttonPanel.add(addSubButton);
    delSubButton.addActionListener(this);
		buttonPanel.add(delSubButton);
    bindButton.addActionListener(this);
		buttonPanel.add(bindButton);
		unbindButton.addActionListener(this);
		buttonPanel.add(unbindButton);
    clearButton.addActionListener(this);
		buttonPanel.add(clearButton);
		add(buttonPanel, new GridBagConstraints(0, 0, 2, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
		
		OutputArea.setEditable(false);
		add(OutputArea, new GridBagConstraints(0, 1, 1, 2, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 5, 0, 5), 0, 0));
  	MsgArea.setEditable(false);
    add(MsgArea, new GridBagConstraints(0, 3, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, -100));
    
		show();
	}//costuttore

	public void windowClosing(WindowEvent evt){
		dispose();
		server.stop();
	}//windowClosing
	
	public void windowActivated(WindowEvent evt) {}
 	public void windowClosed(WindowEvent evt) {}
	public void windowDeactivated(WindowEvent evt) {}
	public void windowDeiconified(WindowEvent evt) {}
	public void windowIconified(WindowEvent evt) {}
	public void windowOpened(WindowEvent evt) {}

	public void writeOut(String s){
		OutputArea.append(s+"\n");
	}
	
	public void actionPerformed(ActionEvent e){
		Button b=(Button)e.getSource();
		if(b.equals(clearButton)){
			OutputArea.setText("");
		} else if(b.equals(addSubButton)){
			try{
				AddSubDialog dial=new AddSubDialog(server,this);
				dial.show();
			}catch (Exception exc){
				MsgArea.append("Impossibile aggiungere sottodominio. "+exc);
			}
		}else if(b.equals(delSubButton)){
			try{
				DelSubDialog dial=new DelSubDialog(server,this);
				dial.show();
			}catch (Exception exc){
				MsgArea.append("Impossibile delegare sottodominio. "+exc);
			}
		}else if(b.equals(bindButton)){
			try{
				BindDialog dial=new BindDialog(server,this);
				dial.show();
			}catch (Exception exc){
				MsgArea.append("Impossibile aggiungere binding. "+exc);
			}
		}else if(b.equals(unbindButton)){
			try{
				UnBindDialog dial=new UnBindDialog(server,this);
				dial.show();
			}catch (Exception exc){
				MsgArea.append("Impossibile eliminare binding. "+exc);
			}
		}
	}

}//PrimaryGui


class BindDialog extends Dialog implements ActionListener,ItemListener,WindowListener{
  GridBagLayout gridBagLayout = new GridBagLayout();
  Label domLabel = new Label("Dominio");
  TextField domField = new TextField();
  Label hostLabel = new Label("Host");
  TextField hostField = new TextField();
  CheckboxGroup checkboxGroup = new CheckboxGroup();
  Checkbox asCheck = new Checkbox("Authentication Server",checkboxGroup,false);
  Checkbox userCheck = new Checkbox("Utente",checkboxGroup,true);
  Checkbox nsCheck = new Checkbox("Name Server",checkboxGroup,false);
  TextField userField = new TextField();
  Button okButton = new Button("OK");
  TextField portField = new TextField();
  Label portLabel = new Label("Porta");
	
	PrimaryServer server;
	PrimaryGui parent;
	
	public BindDialog(PrimaryServer server,PrimaryGui parent){
		super(parent,"Inserimento Binding",true);
		this.server=server;
		this.parent=parent;
		addWindowListener(this);
		setBackground(Color.lightGray);
		setSize(new Dimension(400, 300));
		setLayout(gridBagLayout);
    add(domLabel, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    domField.setText(server.getDomain().toString());
		add(domField, new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 10), 0, 0));
    add(hostLabel, new GridBagConstraints(0, 4, 1, 2, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    add(hostField, new GridBagConstraints(1, 4, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 10), 0, 0));
    asCheck.addItemListener(this);
		add(asCheck, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    userCheck.addItemListener(this);
		add(userCheck, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    nsCheck.addItemListener(this);
		add(nsCheck, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    add(userField, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 10), 0, 0));
    okButton.addActionListener(this);
		add(okButton, new GridBagConstraints(0, 7, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 10, 0), 0, 0));
    add(portField, new GridBagConstraints(1, 5, 1, 2,  1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 10), 0, 0));
    add(portLabel, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));	
	}

	public void actionPerformed(ActionEvent e) {
		try{
			//bottone ok azionato
			DNSName name;
			if (checkboxGroup.getSelectedCheckbox().equals(userCheck)){
				//inserimento utente:
				name=new DNSName(userField.getText()+"@"+domField.getText());
			} else if (checkboxGroup.getSelectedCheckbox().equals(asCheck)){
				//inserimento AS:
				name=new ASName(domField.getText());
			} else {
				//inserimento NS: 
				Domain domain=new Domain(domField.getText());
				name=new NSName(domain);

			}
			InetAddress addr=InetAddress.getByName(hostField.getText());
			int port=Integer.parseInt(portField.getText());
			Binding bind=new Binding(name,new Value(addr,port));
			server.bind(bind);
			parent.MsgArea.append("Binding effettuato "+bind+"\n");
			dispose();
		}catch(UnknownHostException exc){
			parent.MsgArea.append("Host sconosciuto:"+exc.getMessage()+"\n");
			dispose();	
		}catch(Exception exc){
			parent.MsgArea.append("Impossibile completare binding:"+exc.getMessage()+"\n");
			dispose();
		}
	}
	
	public void itemStateChanged(ItemEvent e) {
    if (checkboxGroup.getSelectedCheckbox().equals(userCheck)) {
        userField.setEditable(true);
    } else {
        userField.setText("");
				userField.setEditable(false);
    }
		if (checkboxGroup.getSelectedCheckbox().equals(asCheck)) {
        domField.setText(server.getDomain().toString());
				domField.setEditable(false);
    } else {
				domField.setEditable(true);
    }
	}
	
	public void windowClosing(WindowEvent evt){
		dispose();
	}//windowClosing
	
	public void windowActivated(WindowEvent evt) {}
 	public void windowClosed(WindowEvent evt) {}
	public void windowDeactivated(WindowEvent evt) {}
	public void windowDeiconified(WindowEvent evt) {}
	public void windowIconified(WindowEvent evt) {}
	public void windowOpened(WindowEvent evt) {}

}

class UnBindDialog extends Dialog implements ActionListener,WindowListener,ItemListener {
  GridBagLayout gridBagLayout = new GridBagLayout();
  Label domLabel = new Label("Dominio");
  TextField domField = new TextField();
  CheckboxGroup checkboxGroup = new CheckboxGroup();
  Checkbox asCheck = new Checkbox("Authentication Server",checkboxGroup,false);
  Checkbox userCheck = new Checkbox("Utente",checkboxGroup,true);
  Checkbox nsCheck = new Checkbox("Name Server",checkboxGroup,false);
  TextField userField = new TextField();
  Button okButton = new Button("OK");

  PrimaryServer server;
	PrimaryGui parent;
	
  public UnBindDialog(PrimaryServer server,PrimaryGui parent){
		super(parent,"Eliminazione Binding",true);
		this.server=server;
		this.parent=parent;
		
    setSize(new Dimension(400, 200));
    setLayout(gridBagLayout);
    add(domLabel, new GridBagConstraints(0, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
   	domField.setText(server.getDomain().toString());
		add(domField, new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 10), 0, 0));
    asCheck.addItemListener(this);
		add(asCheck, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
    userCheck.addItemListener(this);
		add(userCheck, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
    nsCheck.addItemListener(this);
		add(nsCheck, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
    add(userField, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 10), 0, 0));
    okButton.addActionListener(this);
		add(okButton, new GridBagConstraints(0, 5, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 10, 0), 0, 0));
  }

	public void itemStateChanged(ItemEvent e) {
    if (checkboxGroup.getSelectedCheckbox().equals(userCheck)) {
        userField.setEditable(true);
    } else {
        userField.setText("");
				userField.setEditable(false);
    }
		if (checkboxGroup.getSelectedCheckbox().equals(asCheck)) {
        domField.setText(server.getDomain().toString());
				domField.setEditable(false);
    } else {
				domField.setEditable(true);
    }
	}
	
		public void actionPerformed(ActionEvent e) {
		try{
			//bottone ok azionato
			DNSName name;
			if (checkboxGroup.getSelectedCheckbox().equals(userCheck)){
				//inserimento utente:
				name=new DNSName(userField.getText()+"@"+domField.getText());
			} else if (checkboxGroup.getSelectedCheckbox().equals(asCheck)){
				//inserimento AS:
				name=new ASName(domField.getText());
			} else {
				//inserimento NS: 
				Domain domain=new Domain(domField.getText());
				name=new NSName(domain);
			}
			server.unbind(name);
			parent.MsgArea.append("Binding eliminato. \n");
			dispose();
		}catch(BindNotFoundException exc){
			parent.MsgArea.append("Binding non presente.\n");
			dispose();	
		}catch(Exception exc){
			parent.MsgArea.append("Impossibile eliminare binding:"+exc.getMessage()+"\n");
			dispose();
		}
	}
	
	public void windowClosing(WindowEvent evt){
		dispose();
	}//windowClosing
	
	public void windowActivated(WindowEvent evt) {}
 	public void windowClosed(WindowEvent evt) {}
	public void windowDeactivated(WindowEvent evt) {}
	public void windowDeiconified(WindowEvent evt) {}
	public void windowIconified(WindowEvent evt) {}
	public void windowOpened(WindowEvent evt) {}
}

class AddSubDialog extends Dialog implements ActionListener,WindowListener {
  Label domLabel = new Label();
  TextField domField = new TextField();
	Button okButton = new Button("OK");
	PrimaryServer server;
	PrimaryGui parent;
	
  public AddSubDialog(PrimaryServer server,PrimaryGui parent) {
    super(parent, "Creazione sottodominio", true);
    this.server=server;
		this.parent=parent;
		setSize(new Dimension(400, 170));
    addWindowListener(this);
		setLayout(new GridBagLayout());
    add(domLabel, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(10, 10, 10, 10), 0, 0));
   	if(server.getDomain().isRoot())
			domLabel.setText(server.getDomain().toString());
		else domLabel.setText("."+server.getDomain());
		add(domField, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(10, 10, 10, 10), 0, 0));
  	okButton.addActionListener(this);
		add(okButton, new GridBagConstraints(0, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
    
	}
	
	public void actionPerformed(ActionEvent e) {
		try{
			//bottone ok azionato
			server.addSubdomain(new Domain(domField.getText()+domLabel.getText()));
			dispose();
		}catch(Exception exc){
			parent.MsgArea.append("Impossibile aggiungere sottodominio:"+exc.getMessage()+"\n");
			dispose();
		}
	}//actionPerformed
	
	public void windowClosing(WindowEvent evt){
		dispose();
	}//windowClosing
	
	public void windowActivated(WindowEvent evt) {}
 	public void windowClosed(WindowEvent evt) {}
	public void windowDeactivated(WindowEvent evt) {}
	public void windowDeiconified(WindowEvent evt) {}
	public void windowIconified(WindowEvent evt) {}
	public void windowOpened(WindowEvent evt) {}


}


class DelSubDialog extends Dialog implements ActionListener,WindowListener {
  GridBagLayout gridBagLayout = new GridBagLayout();
  Label hostLabel = new Label("Host NS sottodominio");
  TextField hostField = new TextField();
  Label portLabel = new Label("Porta NS sottodominio");
  TextField portField = new TextField();
  Label domLabel = new Label("Sottodominio da delegare");
  TextField domField = new TextField();
  Button okButton = new Button("OK");
	
	PrimaryServer server;
	PrimaryGui parent;
	
  public DelSubDialog(PrimaryServer server,PrimaryGui parent) {
    super(parent, "Creazione sottodominio", true);
    this.server=server;
		this.parent=parent;

		setLayout(gridBagLayout);
    setSize(new Dimension(394, 199));
    add(hostLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 15, 5, 5), 0, 1));
    add(hostField, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 15), 0, 0));
    add(portLabel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 15, 15, 5), 0, 0));
    add(portField, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 15, 15), 0, 0));
    add(domLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(15, 15, 5, 5), 0, 0));
    add(domField, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(15, 5, 5, 15), 0, 0));
    add(okButton, new GridBagConstraints(0, 3, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
		okButton.addActionListener(this);
		addWindowListener(this);
	}
	
	public void actionPerformed(ActionEvent e) {
		try{
			//bottone ok azionato
			Domain dom=new Domain(domField.getText());
			InetAddress addr=InetAddress.getByName(hostField.getText());
			int port=Integer.parseInt(portField.getText());
			Binding bind=new Binding(new NSName(dom),new Value(addr,port));
			server.delSubdomain(dom);
			server.bind(bind);
			dispose();
		}catch(Exception exc){
			parent.MsgArea.append("Impossibile delegare sottodominio:"+exc.getMessage()+"\n");
			dispose();
		}
	}//actionPerformed
	
	public void windowClosing(WindowEvent evt){
		dispose();
	}//windowClosing
	

	public void windowActivated(WindowEvent evt) {}
 	public void windowClosed(WindowEvent evt) {}
	public void windowDeactivated(WindowEvent evt) {}
	public void windowDeiconified(WindowEvent evt) {}
	public void windowIconified(WindowEvent evt) {}
	public void windowOpened(WindowEvent evt) {}


}
