package Dns.Msg;

import java.io.*;
import java.net.*;
import Dns.Value;
import Dns.DNSName;


public class BindFoundMsg extends AnswerMsg implements CachableMsg{
	//Nome richiesto:
	//necessario per verificare che non ci sia stata sostituzione 
	//del messaggio di richiesta:
	protected transient DNSName req;
	//valore del Bindinf trovato:
	protected transient Value[] answ;
	//time to live dell'informazione:
	protected transient int TTL;
	
	
	
	//serializzazione dell'oggetto////////////////////////////
	protected BindFoundMsg(){
		req=null;answ=null;TTL=0;timestamp=0;
	}
	
	private void writeObject(ObjectOutputStream out) throws IOException {
		out.writeObject(req);
		out.writeObject(answ);
		out.writeInt(TTL);
	}
	
	private void readObject(ObjectInputStream in) throws IOException,ClassNotFoundException{
		req=(DNSName)in.readObject();
		answ=(Value[])in.readObject();
		TTL=in.readInt();
	}
	///////////////////////////////////////////////////////////
	
	public BindFoundMsg(DNSName req,Value[] answ,int TTL,int timestamp){
		this.req=req;
		this.answ=answ;
		this.TTL=TTL;
		this.timestamp=timestamp;
	}//costruttore
	
	public Value[] getValue(){
		return answ;
	}//getAddress
	
	public int getTimeToLive(){
		return TTL;
	}//getTimeToLive
	
	public DNSName getName(){
		return req;
	}//getName
	
	public String toString(){
		String s="";
		for(int i=0;i<answ.length;i++)
			s=s+answ[i].toString()+" ";
		return "trovato!: "+s;
	}

}//class BindFoundMsg
