package Dns.Msg;

//Messaggio di richiesta di risoluzione di un nome

import java.io.*;
import Dns.DNSName;
import Dns.Parser;
import javax.naming.InvalidNameException;

public class NameQueryMsg extends QueryMsg{
	//il nome da risolvere
	protected transient DNSName query;	
	protected transient boolean islocal;
	
	
	//serializzazione dell'oggetto///////////////////////////////
	protected NameQueryMsg(){
		query=null;islocal=false;timestamp=0;
	}
	
	private void writeObject(ObjectOutputStream out) throws IOException {
		out.writeObject(query);
		out.writeBoolean(islocal);
	}
	
	private void readObject(ObjectInputStream in) throws IOException,ClassNotFoundException{
		query=(DNSName)in.readObject();
		islocal=in.readBoolean();
	}
	////////////////////////////////////////////////////////////////
	
	public NameQueryMsg(DNSName query,boolean islocal,int timestamp){
		this.query=query;
		this.islocal=islocal;
		this.timestamp=timestamp;
	}//costruttore
	
	public NameQueryMsg(DNSName query,int timestamp){
		this(query,false,timestamp);
	}//costruttore
	
	public NameQueryMsg(String query,int timestamp) throws InvalidNameException{
		this((new Parser(query)).getName(),timestamp);
	}//costruttore
	
	public DNSName getQuery(){
		return query;
	}//getQuery
	
	public boolean isLocal(){
		return islocal;
	}//isLocal

	
	public String toString(){
		return (islocal?"Local q":"Q")+"uery "+" for "+query;
	}//toString
	
}
