//Messaggio di risposta con NS competente
package Dns.Msg;

import java.io.*;
import java.net.*;
import Dns.Value;
import Dns.DNSName;

public class ReferToMsg extends SignedMsg implements CachableMsg{
	//binding a cui riferirsi:
	protected transient DNSName ns;
	protected transient Value[] value;
	//timetolive dell'informazione per il caching;
	protected transient int TTL;	
	
	//serializzazione dell'oggetto/////////////////////////////
	protected ReferToMsg(){
		ns=null;value=null;TTL=0;timestamp=0;
	}
	
	private void writeObject(ObjectOutputStream out) throws IOException {
		out.writeObject(ns);
		out.writeObject(value);
		out.writeInt(TTL);
	}
	
	private void readObject(ObjectInputStream in) throws IOException,ClassNotFoundException{
		ns=(DNSName)in.readObject();
		value=(Value[])in.readObject();
		TTL=in.readInt();
	}
	/////////////////////////////////////////////////////////
	
	public ReferToMsg(DNSName ns,Value[] value,int TTL,int timestamp){
		this.ns=ns;
		this.value=value;
		this.TTL=TTL;
		this.timestamp=timestamp;
	}//costruttore
	
	public DNSName getName(){
		return ns;
	}//getName

	public Value[] getValue(){
		return value;
	}//getName
	
	public int getTimeToLive(){
		return TTL;
	}//getTimeToLive
	
		
	public String toString(){
		String s="refer to: "+ns+"-> ";
		for(int i=0;i<value.length;i++){
			s=s+value[i].toString()+",";
		}
		return s;
	}
	
}//ReferToMsg
