package Dns.Msg;

import iaik.security.rsa.RSASignature;
import iaik.security.rsa.*;
import iaik.java.security.*;
import com.entrust.util.*;
import com.entrust.security.provider.RSA;
import iaik.security.rsa.ShaRSASignature;
import java.net.*;
import java.io.*;
import java.util.*;
import Security.RSAKeyGen;
import Msg.PacketMsg;
import Exceptions.*;

//Messaggio "firmato" digitalmente.

public abstract class SignedMsg extends TimestampedMsg{
	//Chiavi
	protected final static RSAPrivateKey privkey=RSAKeyGen.readPrivate("priv.privkey");
	protected final static RSAPublicKey pubkey=RSAKeyGen.readPublic("pub.pubkey");
	
	//Questa implementazione usa la serializzazione:
	
	public DatagramPacket writeToPacket(InetAddress addr,int port) throws Exception{ 
			Util.initCiphers();
			
			ByteArrayOutputStream baos=new ByteArrayOutputStream();
			ObjectOutputStream oos=new ObjectOutputStream(baos); 
 			oos.writeObject(this);			
			//Signature
			ShaRSASignature sign=new ShaRSASignature();
			
			//sign.initSign((PrivateKey)keys.getPrivate());
			sign.initSign(privkey);
			byte[]d =baos.toByteArray();
			//System.out.println("Lungh. dati==>"+d.length);
			sign.update(d);
			byte[] s=sign.sign();
			//System.out.println("Lungh. signature==>"+s.length);
 			oos.writeObject(s);
			
			
			
			//pacchetto
			byte[] arr=baos.toByteArray();
			//controllo che il pacchetto sia minore di 512byte;
			//System.out.println("Controllo Dimensioni Pacchetto==>"+arr.length);
			if(arr.length>dimPacket) {
				//System.out.println("lunghezza="+arr.length);
				throw new MsgTooLongException();
			}
			return new DatagramPacket(arr,arr.length,addr,port);
	}// writeToPacket
	
	public static PacketMsg readFromPacket(DatagramPacket p) throws Exception{
		Util.initCiphers();
		ByteArrayInputStream bais=new ByteArrayInputStream(p.getData());
		ObjectInputStream oin = new ObjectInputStream(bais);		
		//lettura messaggio
		SignedMsg msg= (SignedMsg)oin.readObject();
		System.out.println("ricevuto==>"+msg);
		
		//lettura signature
		byte[] signature=(byte[])oin.readObject();

		ShaRSASignature sign=new ShaRSASignature();
		sign.initVerify(pubkey); 
		byte[]d =msg.toByteArray();
		System.out.println("Lungh. dati==>"+d.length);
		sign.update(d);
 		if (sign.verify(signature)) {
				System.out.println("Signature correct!");
				return msg;
		}else{
			throw new SecurException("Signature not correct!");
		}

	}// readFromPacket

}//abstract class SignedMsg
