package Dns;
//Classe per il parsing dei nomi;
//Sintassi dei nomi:
//
//Name  ::= Type '@' Dominio
//Modificando questa classe si possono aggiungere
//altri servizi o tipi

//se la stirnga e solo un dominio si assume venga richiesto il NS corr.
import javax.naming.InvalidNameException;
import java.util.StringTokenizer;

public class Parser extends NameParser{
	protected StringTokenizer st;
	protected Type type=null;
	protected Domain dom=null;
	
	public Parser(String s) throws InvalidNameException{
		st=new StringTokenizer(s,"@",false);
		int n=st.countTokens();
		if(n==1) {
			dom=new Domain(st.nextToken());
			type=new NSType();
		}	else if(n==2){
			String id=st.nextToken();
			if(id.equals((new ASType()).getName()))
				type=new ASType();
			else if(id.equals((new NSType()).getName()))
				type=new NSType();
			else
				type=new UserType(id);
			dom=new Domain(st.nextToken());
		}else throw new InvalidNameException("Sintassi del nome non corretta");
		
		
	}//costruttore
	
	public DNSName getName() throws InvalidNameException {
	 return new DNSName(getType(),getDomain());	
	}
	
	public Domain getDomain(){
		return dom;
	}//getDomain
	
	public Type  getType(){
		return type; 
	}//getType
	
	public static void main(String args[]){
		Parser p=null;
		try{
			p=new Parser("bucci@alma.unibo.it");
		}catch(Exception e){
			System.out.println(e);
		}
		System.out.println(p.getType());
		System.out.println(p.getDomain());
	}
}//class NameParser
