package Dns;

//Contiene i dati necessari ad un NS
// - La tabella delle associazioni
// - Una Lista dei sottodomini delegati
// - Una Lista dei sottodomini non delegati
import java.util.*;
import java.io.*; 

	public class Table extends BindingsTable{
	protected transient HashSet subdomdel;		//lista dei sottodomini delegati
	protected transient HashSet subdomundel;	//lista dei sottodomini non delegati
	
	//serializzazione////////////////////////////
	private void writeObject(ObjectOutputStream out) throws IOException {
		out.writeInt(subdomdel.size());
		Iterator it=subdomdel.iterator();
		while(it.hasNext())
			out.writeObject(it.next());
		out.writeInt(subdomundel.size());	
		it=subdomundel.iterator();
		while(it.hasNext())
			out.writeObject(it.next());
	}//writeObject
	
	private void readObject(ObjectInputStream in) throws IOException,ClassNotFoundException{
		subdomdel=new HashSet();
		subdomundel=new HashSet();
		for(int count=in.readInt();count>0;count--)
			subdomdel.add((Domain)in.readObject());
		for(int count=in.readInt();count>0;count--)
			subdomundel.add((Domain)in.readObject()); 
	}//readObject
	
	/////////////////////////////////////////////
	
	public Table(){
		super();
		subdomdel=new HashSet();
		subdomundel=new HashSet();
	}//costruttore
	
	//appartenenza ai sottodomini
	public synchronized boolean containsSubdomain(Domain d){
		return (subdomdel.contains(d) || subdomundel.contains(d));
	}
	
	//app. ai sott. delegati
	public synchronized boolean containsSubdomainDel(Domain d){
		return (subdomdel.contains(d));
	}
	
	//prima  necessario creare un sottodominio
	public synchronized void addSubdomain(Domain d){
		subdomundel.add(d);
	}
	
	//poi si pu delegare
	public synchronized boolean delegateSubdomain(Domain d){
		if (!containsSubdomain(d))
			return false;
		else if(!containsSubdomainDel(d)){
			subdomundel.remove(d);
			subdomdel.add(d);
		}
		return true;
	}
	
	public String toString(){
	 return "		subdom. delegati="+subdomdel+"\n"+
			"		subdom. non delegati="+subdomundel+"\n"+
			"		Bindings:\n"+table;
	}
	
	protected Object clone(){
		try{
			ByteArrayOutputStream baos=new ByteArrayOutputStream();
			ObjectOutputStream oos=new ObjectOutputStream(baos); 
	 		oos.writeObject(this);	
			oos.close();	
			ObjectInputStream ois=new ObjectInputStream(new ByteArrayInputStream(baos.toByteArray()));
			return (Table)ois.readObject();
		}catch(Exception e){
			return null;
		}
	}
	
	public Table makeCopy(){
		return (Table)clone();
	}
	
}//class Table
