package Dns;

import java.net.InetAddress;
import java.io.*;

public class Value implements Serializable{
 	transient InetAddress addr;
	transient int port;
	
	//serializzazione:////////////////////////////////////////////
	public Value(){
		addr=null;
		port=0;
	}
	
	private void writeObject(ObjectOutputStream out) throws IOException {
		out.writeObject(addr.getHostName());
		out.writeInt(port);
	}
	
	private void readObject(ObjectInputStream in) throws IOException,ClassNotFoundException{
		addr=InetAddress.getByName((String)in.readObject());
		port=in.readInt();
	}
	

	public Value(InetAddress addr){
		this.addr=addr;
		port=NameServer.DnsPort;
		
	}
	
	public InetAddress getAddress(){
		return addr;
	}

	public Value(InetAddress addr,int port){
		this.addr=addr;
		this.port=port;
	}

	public boolean equals(Object o){
		if (o instanceof Value){
			return ((addr.equals(((Value)o).getAddress())) && port==(((Value)o).getPort()));
		} else return false;
	}
	
	public int getPort(){
		return port;
	}
	
	
	public int hashCode(){
		return addr.hashCode()+port;
	}
	
	public String toString(){
		return addr.toString()+":"+port;
		
	}
}
