package Msg;

import java.net.*;
import java.io.*;
import java.util.*;
import Exceptions.*;

public abstract class PacketMsg implements Serializable{
	//Dimensione massima dei pacchetti
	public static final int dimPacket=1024;
	
	public DatagramPacket writeToPacket(InetAddress addr,int port) throws Exception{ 
		//pacchetto
		byte[] arr=toByteArray();
		//controllo che il pacchetto sia minore di 1024byte;
		//System.out.println("Controllo Dimensioni Pacchetto==>"+arr.length);
		if(arr.length>dimPacket) {
			throw new MsgTooLongException();
		}
		return new DatagramPacket(arr,arr.length,addr,port);
	}// writeToPacket
	
	protected byte[] toByteArray() throws Exception{
		ByteArrayOutputStream baos=new ByteArrayOutputStream();
		ObjectOutputStream oos=new ObjectOutputStream(baos); 
 		oos.writeObject(this);
		oos.close();
		byte[] arr=baos.toByteArray();
		baos.close();
		return arr;
	}
	
	public static PacketMsg readFromPacket(DatagramPacket p) throws Exception{
		ByteArrayInputStream bais=new ByteArrayInputStream(p.getData());
		ObjectInputStream oin = new ObjectInputStream(bais);		
		PacketMsg msg= (PacketMsg)oin.readObject();
		return msg;
	}// readFromPacket

}//abstract class PacketMsg
